Index: trunk/src/VBox/Runtime/testcase/tstDir.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstDir.cpp	(revision 7215)
+++ trunk/src/VBox/Runtime/testcase/tstDir.cpp	(revision 7418)
@@ -160,6 +160,6 @@
                                  DirEntry.Info.ModificationTime,
                                  DirEntry.Info.AccessTime);
-                        if (fShortName && DirEntry.cucShortName)
-                            RTPrintf(" %2d %lS\n", DirEntry.cucShortName, DirEntry.uszShortName);
+                        if (fShortName && DirEntry.cwcShortName)
+                            RTPrintf(" %2d %lS\n", DirEntry.cwcShortName, DirEntry.wszShortName);
                         else
                             RTPrintf(" %2d %s\n", DirEntry.cbName, DirEntry.szName);
Index: trunk/src/VBox/Runtime/testcase/tstPath.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstPath.cpp	(revision 7215)
+++ trunk/src/VBox/Runtime/testcase/tstPath.cpp	(revision 7418)
@@ -66,5 +66,5 @@
     if (RT_SUCCESS(rc))
         RTPrintf("UserHome={%s}\n", szPath);
-    
+
     /*
      * RTPathAbsEx
@@ -73,5 +73,5 @@
     static const char *aInput[] =
     {
-        // NULL, NULL, -- assertion in RTStrUtf8ToUcs2
+        // NULL, NULL, -- assertion in RTStrToUtf16
         NULL,                           "/absolute/..",
         NULL,                           "/absolute\\\\../..",
Index: trunk/src/VBox/Runtime/testcase/tstUtf8.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstUtf8.cpp	(revision 7215)
+++ trunk/src/VBox/Runtime/testcase/tstUtf8.cpp	(revision 7418)
@@ -50,5 +50,5 @@
  * Generate a random codepoint for simple UTF-16 encoding.
  */
-static RTUTF16 GetRandUcs2(void)
+static RTUTF16 GetRandUtf16(void)
 {
     RTUTF16 wc;
@@ -100,5 +100,5 @@
     srand((unsigned)RTTimeNanoTS());
     for (int i = 0; i < 30; i++)
-        pwszRand[i] = GetRandUcs2();
+        pwszRand[i] = GetRandUtf16();
     pwszRand[30] = 0;
 
@@ -141,5 +141,5 @@
     srand((unsigned)RTTimeNanoTS());
     for (int i = 0; i < 30; i++)
-        pwszRand[i] = GetRandUcs2();
+        pwszRand[i] = GetRandUtf16();
     pwszRand[30] = 0;
     rc = RTUtf16ToUtf8(pwszRand, &pszUtf8);
@@ -181,5 +181,5 @@
     srand((unsigned)RTTimeNanoTS());
     for (int i = 0; i < 30; i++)
-        pwszRand[i] = GetRandUcs2();
+        pwszRand[i] = GetRandUtf16();
     pwszRand[30] = 0;
 
@@ -223,5 +223,5 @@
     srand((unsigned)RTTimeNanoTS());
     for (int i = 0; i < 30; i++)
-        pwszRand[i] = GetRandUcs2();
+        pwszRand[i] = GetRandUtf16();
     pwszRand[30] = 0;
 
@@ -261,5 +261,5 @@
     srand((unsigned)RTTimeNanoTS());
     for (int i = 0; i < 30; i++)
-        pwszRand[i] = GetRandUcs2();
+        pwszRand[i] = GetRandUtf16();
     pwszRand[30] = 0;
 
@@ -280,5 +280,5 @@
     srand((unsigned)RTTimeNanoTS());
     for (int i = 0; i < 30; i++)
-        pwszRand[i] = GetRandUcs2();
+        pwszRand[i] = GetRandUtf16();
     pwszRand[30] = 0;
 
@@ -488,14 +488,14 @@
         }
 
-        PRTUTF16 puszUcs2;
-        rc = RTStrToUtf16(pszUtf8, &puszUcs2);
+        PRTUTF16 pwszUtf16;
+        rc = RTStrToUtf16(pszUtf8, &pwszUtf16);
         if (rc == VINF_SUCCESS)
         {
-            if (mymemcmp(puszUcs2, g_wszAll, sizeof(g_wszAll), 16))
+            if (mymemcmp(pwszUtf16, g_wszAll, sizeof(g_wszAll), 16))
             {
                 RTPrintf("tstUtf8: FAILURE - the full #1: UTF-8 -> UTF-16 failed compare!\n");
                 g_cErrors++;
             }
-            RTUtf16Free(puszUcs2);
+            RTUtf16Free(pwszUtf16);
         }
         else
@@ -517,9 +517,9 @@
      */
     RTPrintf("tstUtf8: #2: UTF-8 -> UTF-16 -> UTF-8...\n");
-    PRTUTF16 puszUcs2;
-    rc = RTStrToUtf16(&g_szAll[0], &puszUcs2);
+    PRTUTF16 pwszUtf16;
+    rc = RTStrToUtf16(&g_szAll[0], &pwszUtf16);
     if (rc == VINF_SUCCESS)
     {
-        if (mymemcmp(puszUcs2, g_wszAll, sizeof(g_wszAll), 16))
+        if (mymemcmp(pwszUtf16, g_wszAll, sizeof(g_wszAll), 16))
         {
             RTPrintf("tstUtf8: FAILURE - the full #2: UTF-8 -> UTF-16 failed compare!\n");
@@ -528,5 +528,5 @@
 
         char *pszUtf8;
-        rc = RTUtf16ToUtf8(puszUcs2, &pszUtf8);
+        rc = RTUtf16ToUtf8(pwszUtf16, &pszUtf8);
         if (rc == VINF_SUCCESS)
         {
@@ -543,5 +543,5 @@
             g_cErrors++;
         }
-        RTStrUcs2Free(puszUcs2);
+        RTUtf16Free(pwszUtf16);
     }
     else