Index: /trunk/src/VBox/Additions/x11/xclient/clipboard.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/clipboard.cpp	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/clipboard.cpp	(revision 7449)
@@ -19,5 +19,4 @@
 *   Header Files                                                               *
 *******************************************************************************/
-#define LOG_GROUP LOG_GROUP_DEV_VMM_BACKDOOR
 #include <VBox/HostServices/VBoxClipboardSvc.h>
 #include <VBox/log.h>
@@ -40,14 +39,4 @@
 
 #include "clipboard.h"
-
-/* #define DEBUG_CLIPBOARD */
-#if !defined(DEBUG_CLIPBOARD) && defined(LOG_TO_BACKDOOR)
-  /* Disabled unnecessary debug logging in the shared clipboard when
-     LOG_TO_BACKDOOR is defined (to be removed). */
-# undef LogFlow
-# define LogFlow(a) do {} while (0)
-#endif
-
-#define TRACE printf("%s: %d\n", __PRETTY_FUNCTION__, __LINE__); Log(("%s: %d\n", __PRETTY_FUNCTION__, __LINE__))
 
 /** The formats which we support in the guest. These can be deactivated in order to test specific code paths. */
Index: /trunk/src/VBox/Additions/x11/xclient/clipboard.h
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/clipboard.h	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/clipboard.h	(revision 7449)
@@ -20,4 +20,5 @@
 # define __Additions_linux_clipboard_h
 
+#include <VBox/log.h>
 #include "thread.h"                 /* for VBoxGuestThread */
 
@@ -90,4 +91,5 @@
     int init(void)
     {
+        LogFlowThisFunc(("\n"));
         int rc = mThreadFunction.init();
         if (RT_SUCCESS(rc))
@@ -95,4 +97,5 @@
         if (RT_SUCCESS(rc))
             mInit = true;
+        LogFlowThisFunc(("returning %Rrc\n", rc));
         return rc;
     }
@@ -103,6 +106,8 @@
     void uninit(unsigned cMillies = RT_INDEFINITE_WAIT)
     {
+        LogFlowThisFunc(("\n"));
         if (mInit)
             mThread.stop(cMillies, NULL);
+        LogFlowThisFunc(("returning\n"));
     }
 
@@ -112,8 +117,10 @@
     ~VBoxGuestClipboard()
     {
+        LogFlowThisFunc(("\n"));
         if (mInit)
             try {
                 uninit(2000);
             } catch (...) { }
+        LogFlowThisFunc(("returning\n"));
     }
 };
Index: /trunk/src/VBox/Additions/x11/xclient/displaychange-x11.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/displaychange-x11.cpp	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/displaychange-x11.cpp	(revision 7449)
@@ -16,4 +16,5 @@
  */
 
+#include <VBox/log.h>
 #include <VBox/VBoxGuest.h>
 #include <iprt/assert.h>
@@ -32,4 +33,5 @@
     int rc = VINF_SUCCESS, rcSystem, rcErrno;
 
+    LogFlowThisFunc(("\n"));
     rcSystem = system("VBoxRandR --test");
     if (-1 == rcSystem)
@@ -47,4 +49,5 @@
     if (RT_SUCCESS(rc))
         mInit = true;
+    LogFlowThisFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -52,6 +55,8 @@
 void VBoxGuestDisplayChangeThreadX11::uninit(void)
 {
+    LogFlowThisFunc(("\n"));
     VbglR3CtlFilterMask(0, VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST);
     mInit = false;
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -62,4 +67,5 @@
 {
     mThread = pThread;
+    LogFlowThisFunc(("\n"));
     while (!mThread->isStopping())
     {
@@ -73,4 +79,5 @@
             system("VBoxRandR");
     }
+    LogFlowThisFunc(("returning VINF_SUCCESS\n"));
     return VINF_SUCCESS;
 }
@@ -87,4 +94,5 @@
      *       yield() should give it time to get to one of places mentioned above.
      */
+    LogFlowThisFunc(("\n"));
     for (int i = 0; (i < 5) && mThread->isRunning(); ++i)
     {
@@ -92,4 +100,5 @@
         mThread->yield();
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -98,4 +107,5 @@
     int rc = VINF_SUCCESS;
 
+    LogFlowThisFunc(("\n"));
     if (mInit)
         return VINF_SUCCESS;
@@ -111,4 +121,5 @@
     if (RT_SUCCESS(rc))
         mInit = true;
+    LogFlowThisFunc(("returning %Rrc\n, rc"));
     return rc;
 }
@@ -116,4 +127,5 @@
 void VBoxGuestDisplayChangeMonitor::uninit(unsigned cMillies /* = RT_INDEFINITE_WAIT */)
 {
+    LogFlowThisFunc(("\n"));
     if (mInit)
     {
@@ -121,3 +133,4 @@
             mThreadFunction.uninit();
     }
+    LogFlowThisFunc(("returning\n"));
 }
Index: /trunk/src/VBox/Additions/x11/xclient/displaychange.h
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/displaychange.h	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/displaychange.h	(revision 7449)
@@ -19,4 +19,5 @@
 # define __Additions_client_display_change_h
 
+#include <VBox/log.h>
 #include <VBox/VBoxGuest.h>         /* for the R3 guest library functions  */
 
@@ -49,4 +50,5 @@
     ~VBoxGuestDisplayChangeThreadX11()
     {
+        LogFlowThisFunc(("\n"));
         if (mInit)
         {
@@ -57,4 +59,5 @@
             catch(...) {}
         }
+        LogFlowThisFunc(("returning\n"));
     }
     /**
@@ -119,4 +122,5 @@
     ~VBoxGuestDisplayChangeMonitor()
     {
+        LogFlowThisFunc(("\n"));
         try
         {
@@ -124,4 +128,5 @@
         }
         catch(...) {}
+        LogFlowThisFunc(("returning\n"));
     }
 };
Index: /trunk/src/VBox/Additions/x11/xclient/main.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/main.cpp	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/main.cpp	(revision 7449)
@@ -16,6 +16,4 @@
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
-
-// #define LOG_GROUP LOG_GROUP_DEV_VMM_BACKDOOR
 
 #include <VBox/VBoxGuest.h>
@@ -73,4 +71,5 @@
     int rcSystem, rcErrno;
 
+    LogFlowFunc(("\n"));
 #ifdef _POSIX_SAVED_IDS
     rcSystem = setuid(getuid());
@@ -84,4 +83,5 @@
         LogRel(("VBoxClient: failed to drop privileges, error %Rrc.\n", rc));
     }
+    LogFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -142,4 +142,5 @@
     struct sigaction sigAction;
 
+    LogFlowFunc(("\n"));
     sigAction.sa_handler = vboxClientSignalHandler;
     sigemptyset(&sigAction.sa_mask);
@@ -154,4 +155,5 @@
     sigaction(SIGUSR1, &sigAction, NULL);
     sigaction(SIGUSR2, &sigAction, NULL);
+    LogFlowFunc(("returning\n"));
 }
 
Index: /trunk/src/VBox/Additions/x11/xclient/seamless-host.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/seamless-host.cpp	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/seamless-host.cpp	(revision 7449)
@@ -21,5 +21,5 @@
 *****************************************************************************/
 
-#include <iprt/log.h>
+#include <VBox/log.h>
 #include <iprt/err.h>
 
@@ -34,4 +34,5 @@
     int rc = VERR_NOT_SUPPORTED;
 
+    LogFlowThisFunc(("\n"));
     if (mRunning)  /* Assertion */
     {
@@ -63,4 +64,5 @@
         Log(("VBoxClient (seamless): failed to enable seamless capability on host, rc=%Rrc\n", rc));
     }
+    LogFlowThisFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -69,4 +71,5 @@
 void VBoxGuestSeamlessHost::stop(unsigned cMillies /* = RT_INDEFINITE_WAIT */)
 {
+    LogFlowThisFunc(("returning\n"));
     if (!mRunning)  /* Assertion */
     {
@@ -78,4 +81,5 @@
     VbglR3SeamlessSetCap(false);
     mRunning = false;
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -89,4 +93,5 @@
     VMMDevSeamlessMode newMode = VMMDev_Seamless_Disabled;
 
+    LogFlowThisFunc(("\n"));
     int rc = VbglR3SeamlessWaitEvent(&newMode);
     if (RT_SUCCESS(rc))
@@ -97,7 +102,7 @@
             /* A simplified seamless mode, obtained by making the host VM window borderless and
               making the guest desktop transparent. */
-    #ifdef DEBUG
+#ifdef DEBUG
                 LogRelFunc(("VMMDev_Seamless_Visible_Region request received (VBoxClient).\n"));
-    #endif
+#endif
                 mState = ENABLE;
                 mObserver->notify();
@@ -111,7 +116,7 @@
                 /* fall through to case VMMDev_Seamless_Disabled */
             case VMMDev_Seamless_Disabled:
-    #ifdef DEBUG
+#ifdef DEBUG
                 LogRelFunc(("VMMDev_Seamless_Disabled set (VBoxClient).\n"));
-    #endif
+#endif
                 mState = DISABLE;
                 mObserver->notify();
@@ -122,4 +127,5 @@
         LogFunc(("VbglR3SeamlessWaitEvent returned %Rrc (VBoxClient)\n", rc));
     }
+    LogFlowThisFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -130,4 +136,5 @@
 void VBoxGuestSeamlessHost::updateRects(std::auto_ptr<std::vector<RTRECT> > pRects)
 {
+    LogFlowThisFunc(("\n"));
     if (0 == pRects.get())  /* Assertion */
     {
@@ -136,4 +143,5 @@
     }
     VbglR3SeamlessSendRects(pRects.get()->size(), pRects.get()->empty() ? NULL : &pRects.get()->front());
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -146,4 +154,5 @@
 int VBoxGuestSeamlessHostThread::threadFunction(VBoxGuestThread *pThread)
 {
+    LogFlowThisFunc(("\n"));
     if (0 != mHost)
     {
@@ -159,4 +168,5 @@
         }
     }
+    LogFlowThisFunc(("returning VINF_SUCCESS\n"));
     return VINF_SUCCESS;
 }
@@ -167,4 +177,5 @@
 void VBoxGuestSeamlessHostThread::stop(void)
 {
+    LogFlowThisFunc(("\n"));
     if (0 != mHost)
     {
@@ -181,3 +192,4 @@
         }
     }
+    LogFlowThisFunc(("returning\n"));
 }
Index: /trunk/src/VBox/Additions/x11/xclient/seamless-host.h
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/seamless-host.h	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/seamless-host.h	(revision 7449)
@@ -22,4 +22,5 @@
 #include <vector>                   /* for vector */
 
+#include <VBox/log.h>
 #include <VBox/VBoxGuest.h>         /* for the R3 guest library functions  */
 
@@ -121,4 +122,5 @@
     int init(VBoxGuestSeamlessObserver *pObserver)
     {
+        LogFlowThisFunc(("\n"));
         if (mObserver != 0)  /* Assertion */
         {
@@ -127,4 +129,5 @@
         }
         mObserver = pObserver;
+        LogFlowThisFunc(("returning VINF_SUCCESS\n"));
         return VINF_SUCCESS;
     }
@@ -161,4 +164,5 @@
     ~VBoxGuestSeamlessHost()
     {
+        LogFlowThisFunc(("\n"));
         if (mRunning)  /* Assertion */
         {
@@ -170,4 +174,5 @@
             catch(...) {}
         }
+        LogFlowThisFunc(("returning\n"));
     }
 };
Index: /trunk/src/VBox/Additions/x11/xclient/seamless-x11.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/seamless-x11.cpp	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/seamless-x11.cpp	(revision 7449)
@@ -21,7 +21,7 @@
 *****************************************************************************/
 
-#include <iprt/log.h>
 #include <iprt/err.h>
 #include <iprt/assert.h>
+#include <VBox/log.h>
 #include <VBox/VBoxGuest.h>
 
@@ -41,4 +41,5 @@
                                     const char *aPropName, unsigned long *nItems)
 {
+    LogFlowFunc(("\n"));
     Atom propNameAtom = XInternAtom (aDpy, aPropName,
                                      True /* only_if_exists */);
@@ -59,4 +60,5 @@
         return NULL;
 
+    LogFlowFunc(("returning\n"));
     return propVal;
 }
@@ -71,4 +73,5 @@
     int rc = VINF_SUCCESS;
 
+    LogFlowThisFunc(("\n"));
     if (0 != mObserver)  /* Assertion */
     {
@@ -82,4 +85,5 @@
     }
     mObserver = pObserver;
+    LogFlowThisFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -99,8 +103,10 @@
     int error, event;
 
+    LogFlowThisFunc(("\n"));
     mSupportsShape = XShapeQueryExtension(mDisplay, &event, &error);
     mEnabled = true;
     monitorClientList();
     rebuildWindowTree();
+    LogFlowThisFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -110,11 +116,14 @@
 void VBoxGuestSeamlessX11::stop(void)
 {
+    LogFlowThisFunc(("\n"));
     mEnabled = false;
     unmonitorClientList();
     freeWindowTree();
+    LogFlowThisFunc(("returning\n"));
 }
 
 void VBoxGuestSeamlessX11::monitorClientList(void)
 {
+    LogFlowThisFunc(("called\n"));
     XSelectInput(mDisplay, DefaultRootWindow(mDisplay.get()), SubstructureNotifyMask);
 }
@@ -122,4 +131,5 @@
 void VBoxGuestSeamlessX11::unmonitorClientList(void)
 {
+    LogFlowThisFunc(("called\n"));
     XSelectInput(mDisplay, DefaultRootWindow(mDisplay.get()), 0);
 }
@@ -131,4 +141,5 @@
 void VBoxGuestSeamlessX11::rebuildWindowTree(void)
 {
+    LogFlowThisFunc(("called\n"));
     freeWindowTree();
     addClients(DefaultRootWindow(mDisplay.get()));
@@ -153,4 +164,5 @@
     unsigned cChildren;
 
+    LogFlowThisFunc(("\n"));
     if (!XQueryTree(mDisplay.get(), hRoot, &hRealRoot, &hParent, &phChildrenRaw, &cChildren))
         return;
@@ -158,4 +170,5 @@
     for (unsigned i = 0; i < cChildren; ++i)
         addClientWindow(phChildren.get()[i]);
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -163,4 +176,5 @@
 void VBoxGuestSeamlessX11::addClientWindow(const Window hWin)
 {
+    LogFlowThisFunc(("\n"));
     XWindowAttributes winAttrib;
     bool fAddWin = true;
@@ -208,4 +222,5 @@
                                 winAttrib.width, winAttrib.height, cRects, rects);
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -223,4 +238,5 @@
     bool rc = false;
 
+    LogFlowThisFunc(("\n"));
     windowTypeRaw = XXGetProperty(mDisplay, hWin, XA_ATOM, WM_TYPE_PROP, &ulCount);
     if (windowTypeRaw != NULL)
@@ -231,4 +247,5 @@
             rc = true;
     }
+    LogFlowThisFunc(("returning %s\n", rc ? "true" : "false"));
     return rc;
 }
@@ -241,4 +258,5 @@
 {
     /* We use post-increment in the operation to prevent the iterator from being invalidated. */
+    LogFlowThisFunc(("\n"));
     for (VBoxGuestWindowList::iterator it = mGuestWindows.begin(); it != mGuestWindows.end();
                  mGuestWindows.removeWindow(it++))
@@ -246,4 +264,5 @@
         XShapeSelectInput(mDisplay, it->first, 0);
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -258,4 +277,5 @@
     XEvent event;
 
+    LogFlowThisFunc(("\n"));
     /* Start by sending information about the current window setup to the host.  We do this
        here because we want to send all such information from a single thread. */
@@ -279,4 +299,5 @@
         break;
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -288,4 +309,5 @@
 void VBoxGuestSeamlessX11::doConfigureEvent(const XConfigureEvent *event)
 {
+    LogFlowThisFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -303,4 +325,5 @@
         }
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -312,4 +335,5 @@
 void VBoxGuestSeamlessX11::doMapEvent(const XMapEvent *event)
 {
+    LogFlowThisFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -319,4 +343,5 @@
         addClientWindow(event->window);
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -329,4 +354,5 @@
 void VBoxGuestSeamlessX11::doShapeEvent(const XShapeEvent *event)
 {
+    LogFlowThisFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -342,4 +368,5 @@
         iter->second->mapRects = rects;
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -351,4 +378,5 @@
 void VBoxGuestSeamlessX11::doUnmapEvent(const XUnmapEvent *event)
 {
+    LogFlowThisFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -358,4 +386,5 @@
         mGuestWindows.removeWindow(iter);
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -365,4 +394,5 @@
 std::auto_ptr<std::vector<RTRECT> > VBoxGuestSeamlessX11::getRects(void)
 {
+    LogFlowThisFunc(("\n"));
     unsigned cRects = 0;
     std::auto_ptr<std::vector<RTRECT> > apRects(new std::vector<RTRECT>);
@@ -408,4 +438,5 @@
     }
     mcRects = cRects;
+    LogFlowThisFunc(("returning\n"));
     return apRects;
 }
@@ -418,4 +449,7 @@
 bool VBoxGuestSeamlessX11::interruptEvent(void)
 {
+    bool rc = false;
+
+    LogFlowThisFunc(("\n"));
     /* Message contents set to zero. */
     XClientMessageEvent clientMessage = { ClientMessage, 0, 0, 0, 0, 0, 8 };
@@ -425,6 +459,7 @@
     {
         XFlush(mDisplay);
-        return true;
-    }
-    return false;
-}
+        rc = true;
+    }
+    LogFlowThisFunc(("returning %s\n", rc ? "true" : "false"));
+    return rc;
+}
Index: /trunk/src/VBox/Additions/x11/xclient/seamless-x11.h
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/seamless-x11.h	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/seamless-x11.h	(revision 7449)
@@ -20,4 +20,6 @@
 # define __Additions_linux_seamless_x11_h
 
+#include <VBox/log.h>
+
 #include "seamless-guest.h"
 
@@ -136,5 +138,7 @@
     bool init(char *name = NULL)
     {
+        LogFlowThisFunc(("\n"));
         mDisplay = XOpenDisplay(name);
+        LogFlowThisFunc(("returning\n"));
         return (mDisplay != NULL);
     }
@@ -144,6 +148,8 @@
     int close(void)
     {
+        LogFlowThisFunc(("\n"));
         int rc = XCloseDisplay(mDisplay);
         mDisplay = NULL;
+        LogFlowThisFunc(("returning\n"));
         return rc;
     }
@@ -229,11 +235,14 @@
                    VBoxGuestX11Pointer<XRectangle> rects)
     {
+        LogFlowThisFunc(("\n"));
         VBoxGuestWinInfo *pInfo = new VBoxGuestWinInfo(isMapped, x, y, w, h, cRects,
                                                        rects);
         mWindows.insert(std::pair<Window, VBoxGuestWinInfo *>(hWin, pInfo));
+        LogFlowThisFunc(("returning\n"));
     }
 
     void removeWindow(iterator it)
     {
+        LogFlowThisFunc(("called\n"));
         delete it->second;
         mWindows.erase(it);
@@ -242,4 +251,5 @@
     void removeWindow(Window hWin)
     {
+        LogFlowThisFunc(("called\n"));
         removeWindow(find(hWin));
     }
Index: /trunk/src/VBox/Additions/x11/xclient/seamless.h
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/seamless.h	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/seamless.h	(revision 7449)
@@ -18,4 +18,6 @@
 #ifndef __Additions_xclient_seamless_h
 # define __Additions_xclient_seamless_h
+
+#include <VBox/log.h>
 
 #include "seamless-host.h"
@@ -53,4 +55,5 @@
         int rc = VINF_SUCCESS;
 
+        LogFlowThisFunc(("\n"));
         rc = mGuest->start();
         if (RT_SUCCESS(rc))
@@ -62,4 +65,5 @@
             mGuest->stop();
         }
+        LogFlowThisFunc(("returning %Rrc\n", rc));
         return rc;
     }
@@ -140,4 +144,5 @@
         int rc = VINF_SUCCESS;
 
+        LogFlowThisFunc(("\n"));
         if (isInitialised)  /* Assertion */
         {
@@ -165,4 +170,5 @@
             LogFunc(("returning %Rrc (VBoxClient)\n", rc));
         }
+        LogFlowThisFunc(("returning %Rrc\n", rc));
         return rc;
     }
@@ -170,4 +176,5 @@
     void uninit(unsigned cMillies = RT_INDEFINITE_WAIT)
     {
+        LogFlowThisFunc(("\n"));
         if (isInitialised)
         {
@@ -177,4 +184,5 @@
             isInitialised = false;
         }
+        LogFlowThisFunc(("returning\n"));
     }
 
Index: /trunk/src/VBox/Additions/x11/xclient/thread.cpp
===================================================================
--- /trunk/src/VBox/Additions/x11/xclient/thread.cpp	(revision 7448)
+++ /trunk/src/VBox/Additions/x11/xclient/thread.cpp	(revision 7449)
@@ -16,4 +16,5 @@
  */
 
+#include <VBox/log.h>
 #include <iostream>   /* For std::exception */
 
@@ -25,4 +26,5 @@
     int rc = VINF_SUCCESS;
 
+    LogFlowThisFunc(("\n"));
     if (NIL_RTTHREAD == mSelf)  /* Assertion */
     {
@@ -44,4 +46,5 @@
         }
     }
+    LogFlowThisFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -50,4 +53,5 @@
 VBoxGuestThread::~VBoxGuestThread(void)
 {
+    LogFlowThisFunc(("\n"));
     if (NIL_RTTHREAD != mSelf)
     {
@@ -59,4 +63,5 @@
         catch(...) {}
     }
+    LogFlowThisFunc(("returning\n"));
 }
 
@@ -64,4 +69,7 @@
 int VBoxGuestThread::start(void)
 {
+    int rc = VINF_SUCCESS;
+
+    LogFlowThisFunc(("returning\n"));
     if (NIL_RTTHREAD != mSelf)  /* Assertion */
     {
@@ -70,6 +78,8 @@
     }
     mExit = false;
-    return RTThreadCreate(&mSelf, threadFunction, reinterpret_cast<void *>(this),
+    rc = RTThreadCreate(&mSelf, threadFunction, reinterpret_cast<void *>(this),
                           mStack, mType, mFlags, mName);
+    LogFlowThisFunc(("returning %Rrc\n", rc));
+    return rc;
 }
 
@@ -84,4 +94,6 @@
 {
     int rc = VINF_SUCCESS;
+
+    LogFlowFunc(("\n"));
     PSELF pSelf = reinterpret_cast<PSELF>(pvUser);
     pSelf->mRunning = true;
@@ -101,4 +113,5 @@
     }
     pSelf->mRunning = false;
+    LogFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }